﻿//-----繼承變數區-----

// 繼承 COM通道命令是否執行中
extern int intComPortExecutionStatus;
// 繼承 執行Modbus RTU 命令
extern void voidModbusRTUCommExecute();
//--- COM通訊PORT ---
extern HANDLE hOpen;
// --- IR 觸碰屏幕資料 ---
// 0=switch狀態 (0:開啟,1:關閉)
// 1=Toggle狀態 (0:關閉,1:開啟)
// 2=當前時間_年
// 3=當前時間_月
// 4=當前時間_日
// 5=當前時間_時
// 6=當前時間_分
// 7=當前時間_秒
// 8=RTC儲存筆數
// 9=讀取時間_年
// 10=讀取時間_月
// 11=讀取時間_日
// 12=讀取時間_時
// 13=讀取時間_分
// 14=讀取時間_秒
// 15=感應次數
// 16=延遲時間(ms)
extern int intIWSN1510X[17];

//-----全域宣告變數-----


//-----宣告單頁使用變數-----

char charshowDate_0[20], charshowDate_1[5], charshowDate_2[5], charshowDate_3[20], charshowDate_4[20];

void Timer16OnExecute(tWidget *pWidget)
{
    usprintf(charshowDate_0, "%d/%d/%d %d:%d:%d",intIWSN1510X[2],intIWSN1510X[3],intIWSN1510X[4],intIWSN1510X[5],intIWSN1510X[6],intIWSN1510X[7]);
    LabelTextSet(&Label9, charshowDate_0);
    usprintf(charshowDate_1, "%d ",intIWSN1510X[8]);
    LabelTextSet(&Label10, charshowDate_1);
    usprintf(charshowDate_2, "%d ",intIWSN1510X[15]);
    LabelTextSet(&Label20, charshowDate_2);
    CheckBoxValueSet(&CheckBox6,intIWSN1510X[0]);
    CheckBoxValueSet(&CheckBox7,intIWSN1510X[1]);
    //顯示延遲時間
    usprintf(charshowDate_4, "%d.%d", intIWSN1510X[16]/1000,intIWSN1510X[16]%1000 );
    LabelTextSet(&Label22,charshowDate_4);
}

void Frame12OnShow()
{

}

void Timer38OnExecute(tWidget *pWidget)
{
    voidModbusRTUCommExecute();
}

void HotSpot17OnClick(tWidget *pWidget)
{
    hmi_Beep();
    if (intIWSN1510X[8] > 0)
    {
        intIWSN1510X[8] -= 1;
        TimerEnabledSet(&Timer38 ,0);
        while (true) if (intComPortExecutionStatus == 0) break; 
        
        //詢問狀態命令
        char charSendComm[] = {0x01,0x64,0x29,0x01,0x9E,0x57};
        //接收回傳狀態
        char charReceive[15] = {""};
        uart_BinSendCmd(hOpen, charSendComm, sizeof(charSendComm), charReceive,sizeof(charReceive));
        if (charSendComm[0] == charReceive[0] && charSendComm[1] == charReceive[1])
        {
            int intRetYear = (int)(charReceive[5] << 8) + charReceive[6];
            usprintf(charshowDate_3, "%d/%d/%d %d:%d:%d", intRetYear,charReceive[7],charReceive[8],charReceive[9],charReceive[10],charReceive[11]);
            LabelTextSet(&Label11, charshowDate_3);
        }
        
        TimerEnabledSet(&Timer38 ,1);
    }
    else
    {
        LabelTextSet(&Label9, "0");
    }
}

void HotSpot18OnClick(tWidget *pWidget)
{     
    hmi_Beep();
    
    TimerEnabledSet(&Timer38 ,0);
    //詢問狀態命令
    char charSendComm[] = {0x01, 0x06, 0x01, 0x03, 0x00, 0x01, 0xB9, 0xF6};

    if (CheckBoxValueGet(&CheckBox6) > 0)
    {
        charSendComm[5] = 0x00;
        charSendComm[6] = 0x78;
        charSendComm[7] = 0x36;
    }

    while (true) if (intComPortExecutionStatus == 0) break; 
    
    //接收回傳狀態
    char charReceive[8] = {""};
    uart_BinSendCmd(hOpen, charSendComm, sizeof(charSendComm), charReceive,sizeof(charReceive));

    TimerEnabledSet(&Timer38 ,1);
}

void HotSpot19OnClick(tWidget *pWidget)
{
    hmi_Beep();
    
    TimerEnabledSet(&Timer38 ,0);
    //詢問狀態命令
    char charSendComm[] = {0x01, 0x06, 0x01, 0x04, 0x00, 0x01, 0x08, 0x37};

    if (CheckBoxValueGet(&CheckBox7) > 0)
    {
        charSendComm[5] = 0x00;
        charSendComm[6] = 0xC9;
        charSendComm[7] = 0xF7;
    }

    while (true) if (intComPortExecutionStatus == 0) break; 
    
    //接收回傳狀態
    char charReceive[8] = {""};
    uart_BinSendCmd(hOpen, charSendComm, sizeof(charSendComm), charReceive,sizeof(charReceive));

    TimerEnabledSet(&Timer38 ,1);
}

void HotSpot25OnClick(tWidget *pWidget)
{
    hmi_Beep();

    if (intIWSN1510X[16] < 20000)
    {
        TimerEnabledSet(&Timer38 ,0);
        //詢問狀態命令
        char charSendComm[] = {0x01, 0x06, 0x01, 0x0B, 0x03, 0xE8, 0x00, 0x00};
        int intSendDelayTime = intIWSN1510X[16];
        if (intSendDelayTime < 1000)
        {
            intSendDelayTime = 1000;
        }
        else
        {
            intSendDelayTime += 1000;
        }

        charSendComm[5] = intSendDelayTime & 0xFF;
        charSendComm[4] = (intSendDelayTime >> 8) & 0xFF;

        //計算CRC
        unsigned char cmd[8] = {0};
        for (int i = 0;i<8;i++)
        {
            cmd[i] = (unsigned char)charSendComm[i];
        }
        // calculate the 16-bit CRC value of the cmd
        unsigned short ret_crc = CRC16(cmd, sizeof(cmd)-2);
        // put the CRC value in the last 2 bytes of the cmd
        cmd[sizeof(cmd)-2] = ret_crc & 0xff;
        cmd[sizeof(cmd)-1] = ret_crc >>8;

        charSendComm[sizeof(charSendComm)-2] = (char)cmd[sizeof(cmd)-2];
        charSendComm[sizeof(charSendComm)-1] = (char)cmd[sizeof(cmd)-1];

        while (true) if (intComPortExecutionStatus == 0) break; 
        
        //接收回傳狀態
        char charReceive[8] = {""};
        uart_BinSendCmd(hOpen, charSendComm, sizeof(charSendComm), charReceive,sizeof(charReceive));

        TimerEnabledSet(&Timer38 ,1);
    }
    
}

void HotSpot26OnClick(tWidget *pWidget)
{
    hmi_Beep(); 

    if (intIWSN1510X[16] > 500)
    {
        TimerEnabledSet(&Timer38 ,0);
        //詢問狀態命令
        char charSendComm[] = {0x01, 0x06, 0x01, 0x0B, 0x03, 0xE8, 0x00, 0x00};
        int intSendDelayTime = intIWSN1510X[16];
        if (intSendDelayTime == 1000)
        {
            intSendDelayTime = 500;
        }
        else
        {
            intSendDelayTime -= 1000;
        }

        charSendComm[5] = intSendDelayTime & 0xFF;
        charSendComm[4] = (intSendDelayTime >> 8) & 0xFF;

        //計算CRC
        unsigned char cmd[8] = {0};
        for (int i = 0;i<8;i++)
        {
            cmd[i] = (unsigned char)charSendComm[i];
        }
        // calculate the 16-bit CRC value of the cmd
        unsigned short ret_crc = CRC16(cmd, sizeof(cmd)-2);
        // put the CRC value in the last 2 bytes of the cmd
        cmd[sizeof(cmd)-2] = ret_crc & 0xff;
        cmd[sizeof(cmd)-1] = ret_crc >>8;

        charSendComm[sizeof(charSendComm)-2] = (char)cmd[sizeof(cmd)-2];
        charSendComm[sizeof(charSendComm)-1] = (char)cmd[sizeof(cmd)-1];

        while (true) if (intComPortExecutionStatus == 0) break; 
        
        //接收回傳狀態
        char charReceive[8] = {""};
        uart_BinSendCmd(hOpen, charSendComm, sizeof(charSendComm), charReceive,sizeof(charReceive));

        TimerEnabledSet(&Timer38 ,1);
    }
    
}

void HotSpot102OnClick(tWidget *pWidget)
{
    hmi_Beep();
    TimerEnabledSet(&Timer38 ,0);
    while (true) if (intComPortExecutionStatus == 0) break; 
    
    //詢問狀態命令
    char charSendComm[] = {0x01,0x64,0x23,0x00,0x59,0x37};
    //接收回傳狀態
    char charReceive[6] = {""};
    uart_BinSendCmd(hOpen, charSendComm, sizeof(charSendComm), charReceive,sizeof(charReceive));
    if (charSendComm[0] == charReceive[0] && charSendComm[1] == charReceive[1])
    {
        if ((int)charReceive[3] == 0)
        {
            LabelTextSet(&Label10, "0");
            LabelTextSet(&Label11, "----");
        }
    }
    
    TimerEnabledSet(&Timer38 ,1);
}
