﻿//-----繼承變數區-----

//繼承COM通訊PORT
extern HANDLE hOpen;
// --- IR 觸碰屏幕資料 ---
// 0=switch狀態 (0:開啟,1:關閉)
// 1=Toggle狀態 (0:關閉,1:開啟)
// 2=當前時間_年
// 3=當前時間_月
// 4=當前時間_日
// 5=當前時間_時
// 6=當前時間_分
// 7=當前時間_秒
// 8=RTC儲存筆數
// 9=讀取時間_年
// 10=讀取時間_月
// 11=讀取時間_日
// 12=讀取時間_時
// 13=讀取時間_分
// 14=讀取時間_秒
// 15=感應次數
// 16=延遲時間(ms)
extern int intIWSN1510X[17];

//-----全域宣告變數-----

//執行Modbus RTU 命令
void voidModbusRTUCommExecute();
//斷線判斷值
unsigned int unintJudgmentDroppedValue = 0;

//-----宣告單頁使用變數-----
//COM通道執行命令標示
int intComPortStart = 0;
//COM通道命令是否執行中標示
int intComPortExecutionStatus = 0;

void voidModbusRTUCommExecute()
{
    if (intComPortExecutionStatus == 0)
    {
        intComPortExecutionStatus = 1;
        if (intComPortStart == 0)
        {
            //詢問狀態命令  
            char charSendComm[] = {0x01, 0x04, 0x01, 0x04, 0x00, 0x0A, 0x30, 0x30};
            //接收回傳狀態
            char charReceive[25] = {""};
            uart_BinSendCmd(hOpen, charSendComm, sizeof(charSendComm), charReceive,sizeof(charReceive));
            if (charSendComm[0] == charReceive[0] && charSendComm[1] == charReceive[1])
            {
                //當前年
                intIWSN1510X[2] = (int)(charReceive[3] << 8) + charReceive[4];
                //當前月
                intIWSN1510X[3] = (int)(charReceive[5] << 8) + charReceive[6];
                //當前日
                intIWSN1510X[4] = (int)(charReceive[7] << 8) + charReceive[8];
                //當前時
                intIWSN1510X[5] = (int)(charReceive[9] << 8) + charReceive[10];
                //當前分
                intIWSN1510X[6] = (int)(charReceive[11] << 8) + charReceive[12];
                //當前秒
                intIWSN1510X[7] = (int)(charReceive[13] << 8) + charReceive[14];
                //RTC儲存筆數
                intIWSN1510X[8] = (int)(charReceive[17] << 8) + charReceive[18];
            }
            intComPortStart = 1;
        }
        if (intComPortStart == 1)
        {
            //詢問狀態命令  
            char charSendComm[] = {0x01, 0x03, 0x01, 0x03, 0x00, 0x0A, 0x34, 0x31};
            //接收回傳狀態
            char charReceive[25] = {""};
            uart_BinSendCmd(hOpen, charSendComm, sizeof(charSendComm), charReceive,sizeof(charReceive));
            if (charSendComm[0] == charReceive[0] && charSendComm[1] == charReceive[1])
            {
                //switch狀態
                intIWSN1510X[0] = charReceive[4];
                //Toggle狀態
                intIWSN1510X[1] = charReceive[6];
                //感應次數
                intIWSN1510X[15] = (int)(charReceive[15] << 8) + charReceive[16];
                intIWSN1510X[15] = (intIWSN1510X[15] << 16) + (int)(charReceive[17] << 8) + charReceive[18];
                //延遲時間
                intIWSN1510X[16] = (int)(charReceive[19] << 8) + charReceive[20];
            }
            intComPortStart = 0;
        }
        intComPortExecutionStatus = 0;
    }
}

void BitButton15OnClick(tWidget *pWidget)
{

}

void Modbus14OnShow()
{

}
